/*
 * A-maze-ing API
 * This document describes the API of the A-maze-ing evening server.    This API consists of three different endpoints, which are detailed below.   - To register yourself as a player use the Player endpoint.   - To get information about the available mazes and enter a specific maze use the Mazes endpoint.   - To navigate a maze use the Maze endpoint.
 *
 * OpenAPI spec version: v2
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.MoveAction;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * From the current tile where you stand, what actions are available on it and on the surrounding tiles.
 */
@ApiModel(description = "From the current tile where you stand, what actions are available on it and on the surrounding tiles.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2021-12-16T17:15:53.970Z")
public class PossibleActionsAndCurrentScore {
  @SerializedName("possibleMoveActions")
  private List<MoveAction> possibleMoveActions = null;

  @SerializedName("canCollectScoreHere")
  private Boolean canCollectScoreHere = null;

  @SerializedName("canExitMazeHere")
  private Boolean canExitMazeHere = null;

  @SerializedName("currentScoreInHand")
  private Integer currentScoreInHand = null;

  @SerializedName("currentScoreInBag")
  private Integer currentScoreInBag = null;

  @SerializedName("tagOnCurrentTile")
  private Long tagOnCurrentTile = null;

   /**
   * The actions available on your surrounding tiles (lookahead of one tile).
   * @return possibleMoveActions
  **/
  @ApiModelProperty(value = "The actions available on your surrounding tiles (lookahead of one tile).")
  public List<MoveAction> getPossibleMoveActions() {
    return possibleMoveActions;
  }

   /**
   * In the tile where you are standing, is it possible to collect score (from hand to bag).
   * @return canCollectScoreHere
  **/
  @ApiModelProperty(value = "In the tile where you are standing, is it possible to collect score (from hand to bag).")
  public Boolean isCanCollectScoreHere() {
    return canCollectScoreHere;
  }

   /**
   * In the tile where you are standing, is it possible to exit the maze. Remember you will lose any score in hand  and only be rewarded with the score you have in your bag.
   * @return canExitMazeHere
  **/
  @ApiModelProperty(value = "In the tile where you are standing, is it possible to exit the maze. Remember you will lose any score in hand  and only be rewarded with the score you have in your bag.")
  public Boolean isCanExitMazeHere() {
    return canExitMazeHere;
  }

   /**
   * What is the score you currently have in your hand. Find a score collection point and issue a collect  score command to move this score into your bag. Score in your hand is not awarded when you exit a maze.
   * @return currentScoreInHand
  **/
  @ApiModelProperty(value = "What is the score you currently have in your hand. Find a score collection point and issue a collect  score command to move this score into your bag. Score in your hand is not awarded when you exit a maze.")
  public Integer getCurrentScoreInHand() {
    return currentScoreInHand;
  }

   /**
   * What is the score currently in your bag. When you exit the maze this score will be rewarded to your total  overall score.
   * @return currentScoreInBag
  **/
  @ApiModelProperty(value = "What is the score currently in your bag. When you exit the maze this score will be rewarded to your total  overall score.")
  public Integer getCurrentScoreInBag() {
    return currentScoreInBag;
  }

   /**
   * The tag on the current tile
   * @return tagOnCurrentTile
  **/
  @ApiModelProperty(value = "The tag on the current tile")
  public Long getTagOnCurrentTile() {
    return tagOnCurrentTile;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PossibleActionsAndCurrentScore possibleActionsAndCurrentScore = (PossibleActionsAndCurrentScore) o;
    return Objects.equals(this.possibleMoveActions, possibleActionsAndCurrentScore.possibleMoveActions) &&
        Objects.equals(this.canCollectScoreHere, possibleActionsAndCurrentScore.canCollectScoreHere) &&
        Objects.equals(this.canExitMazeHere, possibleActionsAndCurrentScore.canExitMazeHere) &&
        Objects.equals(this.currentScoreInHand, possibleActionsAndCurrentScore.currentScoreInHand) &&
        Objects.equals(this.currentScoreInBag, possibleActionsAndCurrentScore.currentScoreInBag) &&
        Objects.equals(this.tagOnCurrentTile, possibleActionsAndCurrentScore.tagOnCurrentTile);
  }

  @Override
  public int hashCode() {
    return Objects.hash(possibleMoveActions, canCollectScoreHere, canExitMazeHere, currentScoreInHand, currentScoreInBag, tagOnCurrentTile);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PossibleActionsAndCurrentScore {\n");
    
    sb.append("    possibleMoveActions: ").append(toIndentedString(possibleMoveActions)).append("\n");
    sb.append("    canCollectScoreHere: ").append(toIndentedString(canCollectScoreHere)).append("\n");
    sb.append("    canExitMazeHere: ").append(toIndentedString(canExitMazeHere)).append("\n");
    sb.append("    currentScoreInHand: ").append(toIndentedString(currentScoreInHand)).append("\n");
    sb.append("    currentScoreInBag: ").append(toIndentedString(currentScoreInBag)).append("\n");
    sb.append("    tagOnCurrentTile: ").append(toIndentedString(tagOnCurrentTile)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

